using System;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Soap;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using Microsoft.ApplicationBlocks.Data;


namespace BusinessValidation
{
	/// <summary>
	/// This one work unit loads the four tables
	/// being processed into one dataset, and .
	/// </summary>
	public class RoyaltyData : System.ComponentModel.IListSource
	{
		// Connection string, season to taste:
		private static string connString = 
			"workstation id=WAGSLAPTOP;packet size=4096;integrated security=SSPI;data source=\"WAGSLAPTOP\\WAGSLAPTOP\";persist security info=False;initial catalog=pubs";
		private DataSet _data;

		private ArrayList _validators = new ArrayList ();

		public RoyaltyData()
		{
			// Load the database:
			string [] tables = { "titles"}; //, "authors", "titleauthor", "roysched"};

			_data = new DataSet ("Royalty Editor");
			using (SqlConnection connection = new SqlConnection(connString))
			{
				connection.Open();
				SqlHelper.FillDataset (connection, CommandType.Text, 
					"Select * from titles", _data, tables);
				tables[0]="authors";
				SqlHelper.FillDataset (connection,
					CommandType.Text, 
					"Select * from titleauthor INNER JOIN authors ON titleauthor.au_id = authors.au_id",
					 _data, tables);
				tables[0]= "roysched";
				SqlHelper.FillDataset (connection,
					CommandType.Text, "Select * from roysched", _data, tables);
			}

			//Make the relations:
			DataRelation rel = new DataRelation("roySchedForTitle", 
				_data.Tables["titles"].Columns["title_id"],
				_data.Tables["roysched"].Columns["title_id"],true);
			_data.Relations.Add (rel);

			rel = new DataRelation("authorsForTitle", 
				_data.Tables["titles"].Columns["title_id"],
				_data.Tables["authors"].Columns["title_id"],true);
			_data.Relations.Add (rel);

/*			// Add a rule for the royalty rate to be between 10 and 40 percent.
			Validator r = new RangeValidator ("roysched", "royalty", "Royalty must be between 5 and 40",
				5, 40);
			_validators.Add (r);

			// Add the compute value:
			r = new ComputeValidator("authors",
				"royaltyper", "Royalties must sum to 100",
				"Sum (royaltyper)", "title_id", (Int64)100, true);
			_validators.Add (r);

			// Quick demo, save the validators:		
			Stream stream = File.Open("data.xml", FileMode.Create);
			SoapFormatter formatter = new SoapFormatter();

			formatter.Serialize(stream, _validators);
			stream.Close();
*/
			Stream stream = File.Open ("data.xml", FileMode.Open);
			SoapFormatter formatter = new SoapFormatter ();
			_validators = (ArrayList) formatter.Deserialize (stream);

			foreach (Validator v in _validators)
				v.ConnectTo (_data);
		}

		#region IListSource Members

		public System.Collections.IList GetList()
		{
			return (_data as IListSource).GetList ();
		}

		public bool ContainsListCollection
		{
			get
			{
				// TODO:  Add RoyaltyData.ContainsListCollection getter implementation
				return (_data as IListSource).ContainsListCollection;
			}
		}

		#endregion

	}
}
